// Clock, 1 min
// 25.08.2023, Arduino IDE v1.8.19, LZ2WSG, KN34PC
//---------------------------------------------------------------------------------------------------------
const uint8_t TT[2] = {59, 0};

bool m_flag = false;
bool m = false;
uint8_t s = 0;
uint32_t bres = 0;
//---------------------------------------------------------------------------------------------------------
void setup() {
  DDRB |= (1 << PB5) | (1 << PB4) | (1 << PB3) | (1 << PB2) | (1 << PB1); // outputs: 13, 12, 11, 10, 9
  PORTD |= (1 << PD7) | (1 << PD6);  // inputs: 7, 6 buttons pull-ups

  cli();

  TCCR1A = 0;
  TCCR1B = (1 << CS11);     // 8 prescaler -> 16000000 / 8 = 2000000 Hz
  TIMSK1 |= (1 << OCIE1A);  // enable output compare match interrupt

  sei();
}
//---------------------------------------------------------------------------------------------------------
void loop() {
  if (m_flag) {
    if (m)
      PORTB |= (1 << PB4) | (1 << PB3);
    else
      PORTB |= (1 << PB2) | (1 << PB1);

    _delay_ms(250);

    PORTB &= ~((1 << PB4) | (1 << PB3) | (1 << PB2) | (1 << PB1));  // set LOW

    m_flag = false;
  }

  if (!(PIND & (1 << PD7)))  // button "sec at 00"
    s = 0;
}
//---------------------------------------------------------------------------------------------------------
ISR(TIMER1_COMPA_vect) {  // Bresenham's algorithm, https://www.romanblack.com/one_sec.htm
  static bool t0 = false;
  uint8_t t;

  bres += 65536;          // add 65536 ticks to bresenham total

  if (bres >= 1000000) {  // if reached 0.5 second
    bres -= 1000000;      // subtract 0.5 second, retain error

    t0 ^= 1;

    if (t0) {
      s++;
      PORTB |= (1 << PB5);      // set HIGH
    }
    else
      PORTB &= ~(1 << PB5);     // set LOW

    if (!!(PIND & (1 << PD6)))  // button "min adj"
      t = 0;
    else
      t = 1;

    if (s > TT[t]) {
      s = 0;
      m ^= 1;
      m_flag = true;
    }
  }
}
